//
// a s c i i _ m a p . c
//
// Mode 0 ASCII map drawing program
//
// May 5, 2003 by Wataru Nishida (http://www.skyfree.org)
//

#include "gba.h"
#include "8x8.til"

// Screen-related global variables

hword* bcolor = (hword*) BG_PALETTE;	// 0x05000000
hword* tile   = (hword*) VRAM_CHAR(0);	// 0x06000000
hword* map    = (hword*) VRAM_SCRN(28);	// 0x0600E000

void init_screen(void) {
  int i, row, col, bit, val;

  // Initialize palette

  bcolor[ 0 ] = BGR( 0,  0,  0);
  bcolor[ 1 ] = BGR(31, 31, 31);

  // Initialize tiles with ASCII bit map data

  for (i = 0; i < LCD_PAL_COLORS; i++) {
    for (row = 0; row < 8; row++) {
      for (col = 7; col >= 0; col--) {
        bit = (char8x8[ i ][ row ] & (1 << col)) ? 1 : 0;
        if (col % 2)
          val = bit;
        else
          tile[ (i * LCD_VWIDTH) + (row * 4) + ((7 - col) / 2)] = \
          val + (bit << 8);
       }
     }
   }

  // Start LCD display

  register(LCD_BG0)  = LCD_SIZE3232  |		// 32x32 tiles
		       LCD_COLOR256  |		// 256 colors
                       LCD_BGCHAR(0) |		// Base address of char data
		       LCD_BGSCRN(28);		// Base address of screen data
  register(LCD_CTRL) = LCD_BG0EN | LCD_MODE0;	// Mode 0: Use BG 0
 }

int main() {
  int i, j;

  // Initialize text screen

  init_screen();

  // Display all 256 characters

  for (i = 0; i < 16; i++) {
    for (j = 0; j < 16; j++) {
      map[ (i + 2) * LCD_VWIDTH + (j + 7) ] = i * 16 + j;
     }
   }

  // Loop forever

  while (1) { };
 }
