//
// b o x _ t i l e . c
//
// Mode 0 block drawing program using tiles
//
// May 5, 2003 by Wataru Nishida (http://www.skyfree.org)
//

#include "gba.h"

// Screen-related global variables

hword* bcolor = (hword*) BG_PALETTE;	// 0x05000000
hword* tile   = (hword*) VRAM_CHAR(0);	// 0x06000000
hword* map    = (hword*) VRAM_SCRN(28);	// 0x0600E000

void wait(int val) {
  int i, j;

  for (i = 0; i < val; i++)
    for (j = 0; j < val; j++) ;
 }

int main() {
  int i, j, k = 0, idx;

  // Initialize palette

  bcolor[ 0 ] = BGR( 0,  0,  0);	// Black
  bcolor[ 1 ] = BGR( 0,  0, 31);	// Blue
  bcolor[ 2 ] = BGR( 0, 31,  0);	// Green
  bcolor[ 3 ] = BGR( 0, 31, 31);	// Light teal
  bcolor[ 4 ] = BGR(31,  0,  0);	// Red
  bcolor[ 5 ] = BGR(31,  0, 31);	// Purple
  bcolor[ 6 ] = BGR(31, 31,  0);	// Yellow
  bcolor[ 7 ] = BGR(31, 31, 31);	// White

  // Initialize tiles with different colors

  for (i = 0; i < 8; i++) {
    for (j = 0; j < LCD_TILE_HWORD; j++)
      tile[ i * LCD_TILE_HWORD + j ] = (i << 8) + i;
   }

  // Initialize screen data (16x10 blocks)

  for (i = 0; i < 10; i++) {
    for (j = 0; j < 15; j++) {
      idx = (k + i + j) % 8;
      map[ i * LCD_VWIDTH + j * 2      ] = idx;
      map[ i * LCD_VWIDTH + j * 2 +  1 ] = idx;
      map[ i * LCD_VWIDTH + j * 2 + 32 ] = idx;
      map[ i * LCD_VWIDTH + j * 2 + 33 ] = idx;
     }
   }
  k++;

  // Start LCD display

  register(LCD_BG0)  = LCD_SIZE3232  |		// 32x32 tiles
		       LCD_COLOR256  |		// 256 colors
                       LCD_BGCHAR(0) | 		// Base address of char data
		       LCD_BGSCRN(28);		// Base address of screen data
  register(LCD_CTRL) = LCD_BG0EN | LCD_MODE0;	// Mode 0: Use BG 0

  // Redraw the screen

  while (1) {
    wait(150);					// It's too fast. We need wait!
    for (i = 0; i < 10; i++) {
      for (j = 0; j < 15; j++) {
        idx = (k + i + j) % 8;
        map[ (i * LCD_VWIDTH + j) * 2      ] = idx;
        map[ (i * LCD_VWIDTH + j) * 2 +  1 ] = idx;
        map[ (i * LCD_VWIDTH + j) * 2 + 32 ] = idx;
        map[ (i * LCD_VWIDTH + j) * 2 + 33 ] = idx;
       }
     }
    k = (k < 15) ? k + 1 : 0;
   }
 }
