//
// d u n g e o n . c
//
// Dungeon viewer
//
// May 7, 2003 by Wataru Nishida (http://www.skyfree.org)
//

#include "gba.h"
#include "dungeon.pal"
#include "dungeon.til"

hword* bcolor = (hword*) BG_PALETTE;

// Screen information

screen scrn[ 1 ] = {
  { (hword*) VRAM_SCRN(24), (hword*) VRAM_CHAR(0), 0, 0 }	// Page 0
 };

// Virtual dungeon map (16x16)

int vmap[] = {
  2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,0,
  2,3,3,3,4,3,3,3,3,3,4,3,3,3,2,0,
  2,3,3,3,3,3,5,3,5,3,3,3,3,3,2,0,
  2,1,1,1,1,1,1,1,1,1,1,1,1,1,2,0,
  2,2,2,2,1,7,1,1,1,7,1,2,2,2,2,0,
  3,3,3,2,1,1,1,1,1,1,1,2,3,3,3,0,
  3,3,3,2,1,1,1,6,1,1,1,2,3,3,3,0,
  0,0,0,2,1,1,1,1,1,1,1,2,0,0,0,0,
  0,0,0,2,2,2,1,1,1,2,2,2,0,0,0,0,
  0,0,0,3,3,2,1,1,1,2,3,3,0,0,0,0,
  0,0,0,0,0,2,1,1,1,2,0,0,0,0,0,0,
  0,0,0,0,0,2,1,1,1,2,0,0,0,0,0,0,
  0,0,0,0,0,2,1,1,1,2,0,0,0,0,0,0,
  0,0,0,0,0,2,1,1,1,2,0,0,0,0,0,0,
  0,0,0,0,0,2,1,1,1,2,0,0,0,0,0,0,
  0,0,0,0,0,2,1,1,1,2,0,0,0,0,0,0
 };

void init_screen(void) {
  int i, row, col, v, d, s;
  hword *src, *dst;

  // Initialize palette

  for (i = 0; i < 256; i++)
    bcolor[ i ] = bg_palette[ i ];

  // Setup tiles for dungeon map

  src = (hword*) bg_tiles;
  dst = scrn[ 0 ].tile;
  for (i = 0; i < (BG_WIDTH * BG_HEIGHT * LCD_TILE_HWORD); i++) {
    *dst++ = *src++;
   }

  // Build a real screen map from the virtual map

  for (row = 0; row < (LCD_VHEIGHT / 2); row++) {
    for (col = 0; col < (LCD_VWIDTH / 2); col++) {
      v = vmap[ row * (LCD_VWIDTH / 2) + col ];
      d = (v / (BG_WIDTH / 2)) * BG_WIDTH + (v % (BG_WIDTH / 2)) * 2;
      s = (row * 2 * LCD_VWIDTH) + (col * 2);
      scrn[ 0 ].map[ s ] = d;
      scrn[ 0 ].map[ s + 1 ] = d + 1;
      d += BG_WIDTH;
      s += LCD_VWIDTH;
      scrn[ 0 ].map[ s ] = d;
      scrn[ 0 ].map[ s + 1 ] = d + 1;
     }
   }

  // Start LCD display

  register(LCD_BG0)  = LCD_SIZE3232  | LCD_COLOR256 |
                       LCD_BGCHAR(0) | LCD_BGSCRN(24);
  register(LCD_CTRL) = LCD_BG0EN | LCD_MODE0;	// Mode 0: Use BG 0
 }

void wait(int val) {
  int i, j;

  for (i = 0; i < val; i++)
    for (j = 0; j < val; j++) ;
 }

int main() {
  int key, ox = 0, oy = 0;

  // Initialize screen

  init_screen();

  // Loop forever

  while (1) {
    key = register(KEY_STATUS);
    if ((key & KEY_ALL) == KEY_ALL)
      continue;
    key = key ^ KEY_ALL;

    if (key & KEY_UP) {
      if (oy == 0)
        continue;
      oy--;
      register(LCD_BG0_VOFFSET) = oy;
     }
    else if (key & KEY_DOWN) {
      if (oy == (256 - (LCD_RHEIGHT * 8)))
        continue;
      oy++;
      register(LCD_BG0_VOFFSET) = oy;
     }
    else if (key & KEY_RIGHT) {
      if (ox == (256 - (LCD_RWIDTH * 8)))
        continue;
      ox++;
      register(LCD_BG0_HOFFSET) = ox;
     }
    else if (key & KEY_LEFT) {
      if (ox == 0)
        continue;
      ox--;
      register(LCD_BG0_HOFFSET) = ox;
     }
    wait(40);
   };
 }
