//
// h e l l o . c
//
// Mode 0 "Hello, wordl!" on GBA
//
// May 5, 2003 by Wataru Nishida (http://www.skyfree.org)
//

#include "gba.h"
#include "8x8.til"

// Screen-related global variables

hword* bcolor = (hword*) BG_PALETTE;	// 0x05000000
hword* tile   = (hword*) VRAM_CHAR(0);	// 0x06000000
hword* map    = (hword*) VRAM_SCRN(28);	// 0x0600E000

int x = 0, y = 0;	// Cursor location

void init_screen(void) {
  int i, row, col, bit, val;

  // Initialize palettes

  bcolor[ 0 ] = BGR( 0,  0,  0);
  bcolor[ 1 ] = BGR(31, 31, 31);

  // Initialize character data

  for (i = 0; i < LCD_PAL_COLORS; i++) {
    for (row = 0; row < 8; row++) {
      for (col = 7; col >= 0; col--) {
        bit = (char8x8[ i ][ row ] & (1 << col)) ? 1 : 0;
        if (col % 2)
          val = bit;
        else
          tile[ (i * LCD_VWIDTH) + (row * 4) + ((7 - col) / 2)] = \
          val + (bit << 8);
       }
     }
   }

  // Start LCD display

  register(LCD_BG0)  = LCD_SIZE3232  |		// 32x32 tiles
		       LCD_COLOR256  |		// 256 colors
                       LCD_BGCHAR(0) |		// Base address of char data
		       LCD_BGSCRN(28);		// Base address of screen data
  register(LCD_CTRL) = LCD_BG0EN | LCD_MODE0;	// Mode 0: Use BG 0
 }

void locate(int xx, int yy) {
  x = xx;
  y = yy;
 }

void prints(const char* str) {
  const char* ptr = str;

  while (*ptr) {
    map[ y * LCD_VHEIGHT + x++ ] = *ptr++;
   }
 }

int main() {
  // Initialize text screen

  init_screen();

  // Display message

  locate(5, 9);
  prints("\xc9\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xbb");
  locate(5, 10);
  prints("\xba \x01 Hello,world! \x02 \xba");
  locate(5, 11);
  prints("\xc8\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xbc");

  // Loop forever

  while (1) { };
 }
