//
// l o g o _ t i l e s . c
//
// Mode 0 tiled-logo viewer
//
// May 6, 2003 by Wataru Nishida (http://www.skyfree.org)
//

#include "gba.h"
#include "logo.pal"
#include "logo.til"

// Screen-related global variables

hword* bcolor = (hword*) BG_PALETTE;	// 0x05000000
hword* tile   = (hword*) VRAM_CHAR(0);	// 0x06000000
hword* map    = (hword*) VRAM_SCRN(28);	// 0x0600E000

void init_screen(void) {
  int i, j;

  // Initialize palette

  for (i = 0; i < LCD_PAL_COLORS; i++)
    bcolor[ i ] = bg_palette[ i ];

  // Initialize tile data

  for (i = 0; i < (BG_WIDTH * BG_HEIGHT + 1); i++) {
    for (j = 0; j < LCD_TILE_HWORD; j++) {
      tile[ (LCD_TILE_HWORD * i) + j ] = bg_tiles[ i ][ j ];
     }
   }

  // Clear the screen

  for (i = 0; i < LCD_RHEIGHT; i++)
    for (j = 0; j < LCD_RWIDTH; j++)
      map[ i * LCD_VWIDTH + j ] = BG_BLANK;

  // Start LCD display

  register(LCD_CTRL) = LCD_BG0EN | LCD_MODE0;	// Mode 0: Use BG 0
  register(LCD_BG0)  = LCD_SIZE3232  |		// 32x32 tiles
		       LCD_COLOR256  |		// 256 colors
                       LCD_BGCHAR(0) |		// Base address of char data
		       LCD_BGSCRN(28);		// Base address of screen data
 }

void wait(int val) {
  int i, j;

  for (i = 0; i < val; i++)
    for (j = 0; j < val; j++) ;
 }

int main() {
  int row, col, add, i, j;

  // Initialize screen

  init_screen();

  // Loop forever

  while (1) {
    for (row = 0; row < LCD_RHEIGHT; row++) {	// Arrange the title screen
      for (col = 0; col < LCD_RWIDTH; col++) {
        add = LCD_VWIDTH * row + (LCD_RWIDTH - 1 - col);
        for (i = 0; i < (col + 1); i++)
          map[ add + i ] = row * LCD_RWIDTH + i;
        wait(50);
       }
     }
    wait(700);
    for (i = 0; i < LCD_RHEIGHT; i++)		// Clear screen
      for (j = 0; j < LCD_RWIDTH; j++)
        map[ i * LCD_VWIDTH + j ] = BG_BLANK;
   };
 }
